NugPageSwap = CreateFrame("Frame","NugPageSwap")

NugPageSwap:SetScript("OnEvent", function(self, event, ...)
	self[event](self, event, ...)
end)

NugPageSwap:RegisterEvent("ADDON_LOADED")

--~ function print(s)
--~     DEFAULT_CHAT_FRAME:AddMessage(s)
--~ end

stack = {}
function stack.push(self,val)
    self[table.maxn(self)+1] = val
end
function stack.pop(self)
    val = self[table.maxn(self)]
    self[table.maxn(self)] = nil
    return val
end


function NugPageSwap.ADDON_LOADED(self,event,arg1)
    if arg1 == "NugPageSwap" then
        NugPageSwapDB = NugPageSwapDB or { ["LCTRL"] = 2, }
--~         NugPageSwapDB.modifier = NugPageSwapDB.modifier or "LSHIFT"
--~         NugPageSwapDB.page = NugPageSwapDB.page or 2
        
        SLASH_NUGPS1= "/nps"
        SLASH_NUGPS2 = "/nugpageswap"
        SlashCmdList["NUGPS"] = NugPageSwap.SlashCmd
        
        NugPageSwap:RegisterEvent("MODIFIER_STATE_CHANGED")
    end
end

function NugPageSwap.MODIFIER_STATE_CHANGED(self,event,arg1,arg2)
    for k,v in pairs(NugPageSwapDB) do
        if arg1 == k then
            if arg2 == 1 then
                stack:push(GetActionBarPage())
                ChangeActionBarPage(v)
            else
                ChangeActionBarPage(stack:pop())
            end
            return
        end
    end
end

function NugPageSwap.SlashCmd(msg)
    k,v = string.match(msg, "(%w+)=(%w+)")
    
    if k == "help" or not k then
        DEFAULT_CHAT_FRAME:AddMessage("NugPageSwap:\n/nps LCTRL=2\n(LCTRL - modifier; 2 - page numeber between 1 and 6)\nLSHIFT=0 - deletes pair")
        DEFAULT_CHAT_FRAME:AddMessage("Current pairs:")
        for k,v in pairs(NugPageSwapDB) do
            DEFAULT_CHAT_FRAME:AddMessage(k.." : "..v)
        end
    else
        val = tonumber(v)
        if val == 0 then val = nil end
        NugPageSwapDB[string.upper(k)] = val
    end
end